#line -a-

/*Ŀ*/
/* 祭          : ⮡p p ⪮ ᪠           */
/*Ĵ*/
/* 맮               : FIXPARTC [p ᪠] ( 㬮砭 0)        */
/**/

#include <dos.h>
#include <string.h>
#include <stdlib.h>

#define TRUE   ( 1 == 1 )                       
#define FALSE  ( 1 == 0 )

#define HI(x)  ( *((BYTE *) (&x) + 1) )      /* p頥 p訩    */
#define LO(x)  ( *((BYTE *) &x) )            /* p頥 訩    */

typedef unsigned char BYTE;
typedef unsigned int WORD;


typedef struct {                              /* ⮯ ᥪp   */
                BYTE Head;                    /*  ⥭/    */ 
                WORD SecCyl;                  /* p ᥪp  樫p */
                } SECPOS;

typedef struct {                              /* 室  ⠡ p  */
		BYTE          Status;         /* ﭨ p        */
		SECPOS        StartSec;       /* 砫 ᥪp         */
		BYTE          PartTyp;        /*  p              */
		SECPOS        EndSec;         /*  ᥪp          */
		unsigned long SecOfs;         /* 饭 ᥪp p㧪*/
		unsigned long SecNum;         /* ⢮ ᥪp      */
		} PARTENTRY;

typedef struct {                               /* p p        */
		BYTE          BootCode[ 0x1BE ];
		PARTENTRY     PartTable[ 4 ];
		WORD          IdCode;
		} PARTSEC;                      /* OxAA55                 */

typedef PARTSEC far *PARSPTR;   /* ⥫ > ᥪp p     */

/*Ŀ*/
/* ReadPartSec : ⠥ ᥪp p  ᪠  頥  p     */
/*Ĵ*/
/* 室 pp : HrdDrive - BIOS- ᪠(80  81 )        */
/*                   : Head     - p  ⥭/           */
/*                   : SecCyl   - p ᥪ.  樫p  p BIOS */
/*                   : Buf      - p,  p 頥 ᥪp    */
/* 室 pp : TRUE     - ᫨ ᥪp ⠥  訡      */
/*                    : FALSE    -                                 */
/**/

BYTE ReadPartSec( BYTE HrdDrive, BYTE Head, WORD SecCyl, PARSPTR Buf )
{
	union REGS   Regs;           /* p pp  맮    */
	struct SREGS SRegs;          /*   pp뢠                      */

        Regs.x.ax = 0x0201;          /* p 㭪樨 "⥭", 1 ᥪp  */
        Regs.h.dl = HrdDrive;        /* p㧪 pp  pp    */ 
        Regs.h.dh = Head;            
        Regs.x.cx = SecCyl;
        Regs.x.bx = FP_OFF( Buf );
	SRegs.es  = FP_SEG( Buf );

	int86x ( 0x13, &Regs, &Regs, &SRegs); /* 맮 pp뢠        */
					      /* ⪮ ᪠          */
        return !Regs.x.cflag;
}

/*Ŀ*/
/* GetSecCyl   : p p ᥪp  樫p  p BIOS     */
/*Ĵ*/
/* 室 pp : SecCyl  - p ᥪp  樫p  p BIOS*/
/*                   : Sector  -  p "ᥪp"                */
/*                   : Cylinder -  p "樫p"              */
/* 室 pp:                                               */
/**/

void GetSecCyl( WORD SecCyl, int *Sector, int *Cylinder )
{
        *Sector    = SecCyl & 63;              /* 祭 ⮢ 6  7  */
        *Cylinder  = HI( SecCyl ) + ( ( (WORD) LO( SecCyl ) & 192 ) << 2 );

}
/*Ŀ*/
/* ShowPartition  :  ⮡p p ⪮ ᪠  p      */
/*Ĵ*/
/* 室 pp  : DR    - p ᪠                              */
/* 室 pp:                                               */
/**/

void ShowPartition( BYTE LW )
{

#define AP ParSec.PartTable[ Entry ]

	BYTE       Head,                  /*   ⥪饣 p */
		   Entry,                 /* 稪 横                */
		   SecCyl;                /* p  樫p             */
	PARTSEC    ParSec;                /* 騩 ᥪp p     */
	int        Sector,                /* 祭 ᥪp  樫p */
		   Cylinder;              /* p                        */
	union REGS Regs;                  /* p pp          */
					  /*  맮 pp뢠        */
	printf( "\n" );
	LW |= 0x80;                   /* ⮢ p ᪠  BIOS */
	if ( ReadPartSec( LW, 0, 1, &ParSec ) ) /* ⥭ ⥪饣 ⥪ */
	  {                                    /* p ᯥ譮 p⠭ */
	    Regs.h.ah = 8;                     /* ⥭  ᪠     */
	    Regs.h.dl = LW;
	    int86( 0x13, &Regs, &Regs );/* 맮 pp뢠 ⪮ ᪠*/
	    GetSecCyl( Regs.x.cx, &Sector, &Cylinder );
	    printf(""
		   "Ŀ");
	    printf("        %2d:    %2d     %4d "
		   " 樫p %3d  ᥪp             ",
		     LW-0x80, Regs.h.dh+1, Cylinder, Sector );
	    printf("  p  ᥪp p     "
		   "                                    ");
	    printf(""
		   "Ĵ");
	    printf("                              砫       "
		   "       ﭨ -");

	    printf("#.p                        "
		   "     ᥪ..ᥪ. ");

	    printf(""
		   "Ĵ");

	    for(Entry = 0; Entry < 4; ++Entry)
	     {
	      printf( " %d", Entry );
	      if (AP.Status == 0x80 )
		printf("  ");
	      else
	       printf(" ");
	      printf("");
	      switch( AP.PartTyp )           /* ⮡p ⨯ p  */
	       {
		case 0x00 : printf("               ");
			    break;
		case 0x01 : printf("DOS, 12-⮢  FAT   ");
			    break;
		case 0x02 : printf("XENIX                  ");
			    break;
		case 0x03 : printf("XENIX                  ");
			    break;
		case 0x04 : printf("DOS, 16-⮢  FAT   ");
			    break;
		case 0x05 : printf("DOS, . p  ");
			    break;
		case 0xDB : printf("p쭠 DOS       ");
			    break;
		default   : printf("⭠  (%3d)     ",
				   ParSec.PartTable[Entry].PartTyp);
	       }

	      GetSecCyl ( AP.StartSec.SecCyl, &Sector, &Cylinder );
	      printf ( "%2d %5d %3d ",AP.StartSec.Head,Cylinder, Sector );
	      GetSecCyl ( AP.EndSec.SecCyl, &Sector, &Cylinder );
	      printf ( "%2d %5d %3d ",AP.EndSec.Head,Cylinder, Sector );
	      printf ( " %6lu    %6lu",AP.SecOfs, AP.SecNum );
	     }
	    printf(""
		   "");
	  }
	  else
	    printf(" 訡  p 㯠  ᥪp p㧪!\n");
  }

/**************************************************************************/
/*                                                       */
/**************************************************************************/
int main( int argc, char *argv[] )
{
        int HrdDrive;

	HrdDrive = 0;                    /*  㬮砭                  */
	if ( argc == 2 )                 /* ᫨   pp    */
          {                              /*                             */
	    HrdDrive = atoi ( argv[ 1 ]);
	    if ( HrdDrive == 0 && *argv[ 1 ] != '0' )
              {
                printf( "\n p 㪠 !" );
                return( 1 );             /*  pp               */
                }
	    }
	  ShowPartition( HrdDrive );     /* ⮡p ᥪp p */
          return( 0 );
}

