{Ŀ}
{ 祭     : ⮡p p ⪮ ᪠                 }
{Ĵ}
{ 맮          : PART [p ⪮ ᪠] ( 㬮砭 - 0)       }
{}

uses Dos;

type SecPos = record                       { ⮯ ᥪp       }
                Head   : byte;             {  ⥭/        }
                SecCyl : word;             { p ᥪp  樫p     }
              end;

     PartEntry = record                    { 室  ⠡ p      }
                   Status   : byte;        { ﭨ p            }
                   StartSec : SecPos;      { 砫 ᥪp             }
                   PartTyp  : byte;        {  p                  }
                   EndSec   : SecPos;      {  ᥪp              }
                   SecOfs   : longint;     { 饭 ᥪp p㧪    }
                   SecNum   : longint;     { ⢮ ᥪp          }
                 end;

     PartSec   = record                    { p p             }
                   BootCode  : array [0..$1BD] of byte;
                   PartTable : array [1..4] of PartEntry;
                   IdCode    : word;
                 end;

{Ŀ}
{ ReadPartSec : ⠥ ᥪp p  ᪠  頥  p        }
{Ĵ}
{ 室 pp : HrdDrive - BIOS-p ⪮ ᪠($80  $81) }
{                   : Head     - p  ⥭/            }
{                   : SecCyl   - p ᥪp  樫p  p BIOS}
{                   : Buf      - p,  p 頥 ᥪp     }
{}

function ReadPartSec ( HrdDrive, Head : byte;
                       SecCyl         : word;
                       var Buf        : PartSec ) : boolean;

var Regs : Registers;

begin
  Regs.AX := $0201;                   { p 㭪樨 "⥭", 1 ᥪp  }
  Regs.DL := HrdDrive;                { ᥭ ⥫ p- }
  Regs.DH := Head;                    { p  pp                    }
  Regs.CX := SecCyl;
  Regs.ES := seg( Buf );
  Regs.BX := ofs( Buf );
  Intr( $13, Regs );                  { 맮 pp뢠 ⪮ ᪠   }
  ReadPartSec :=
    ( Regs.Flags and 1 ) = 0;         {  p 㪠뢠  訡 }
end;

{Ŀ}
{ GetSecCyl   : p p ᥪp  樫p  p BIOS      }
{Ĵ}
{ 室 pp : SecCyl   - p ᥪp  樫p  p BIOS}
{                   : Sector   -  p "ᥪp"                }
{                   : Cylinder -  p "樫p"               }
{}

procedure GetSecCyl ( SecCyl : word; var Sector, Cylinder : integer );

begin
  Sector   := SecCyl and 63;               { 祭 ⮢ 6  7       }
  Cylinder := hi( SecCyl ) + ( lo( SecCyl ) and 192 ) shl 2;
end;

{Ŀ}
{ ShowPartition  :  ⮡p p ⪮ ᪠  p       }
{Ĵ}
{ 室 pp  : DR  - p ᪮ ᪠ (0, 1, 2  ..)    }
{}

procedure ShowPartition ( DR : byte );

var Head     : byte;                  {   ⥪饣 p      }
    SecCyl   : byte;                  { p  樫p                  }
    ParSec   : PartSec;               { 騩 ᥪp p          }
    Entry    : byte;                  { 稪 横                     }
    Sector,                           {  p ᥪp          }
    Cylinder : integer;               { 樫p                          }
    Regs     : Registers;             { p pp  맮    }
                                      { pp뢠                        }
begin
  writeln;
  DR := DR + $80;                     { ⮢ p ᪠  BIOS  }
  if ReadPartSec ( DR, 0, 1, ParSec ) then { ⥭ ᥪp p     }
    begin                                  { p ᯥ譮 p⠭      }
      Regs.AH := 8;                        { ⥭  ᪠          }
      Regs.DL := DR;
      Intr( $13, Regs );              { 맮 pp뢠 ⪮ ᪠   }
      GetSecCyl ( Regs.CX, Sector, Cylinder );
write('');
write('Ŀ');
write('       ',DR-$80,': ',Regs.DH+1:2,'   ',
     Cylinder:5,' 樫p  ',Sector:3,' ᥪp                   ');
write('  p  ᥪp p');
write('                                         ');
write('');
write('Ĵ');
write('                               ');
write('             ﭨ -');
write(' #p                      ');
write('       ᥪ..ᥪ. ');
write('');
write('Ĵ');

      for Entry := 1 to 4 do               { p⪠ ⠡             }
        with ParSec.PartTable[ Entry ] do
          begin
            write(' ', Entry, '');
            if Status = $80 then write ('  ')
                            else write (' ');
            write('');
            case PartTyp of                { ⮡p ⨯ p     }
              $00    : write('                ');
              $01    : write('DOS, 12-⮢ FAT     ');
              $02    : write('XENIX                   ');
              $03    : write('XENIX                   ');
              $04    : write('DOS, 16-⮢ FAT     ');
              $05    : write('DOS, . p   ');
              $DB    : write('p쭠 DOS        ');
              else     write('⭠ (',PartTyp:3,')    ');
            end;
            GetSecCyl ( StartSec.SecCyl, Sector, Cylinder);
            write('',StartSec.Head:2,' ',Cylinder:5,' ',Sector:3 );
            GetSecCyl ( EndSec.SecCyl, Sector, Cylinder);
            write(' ',EndSec.Head:2,' ',Cylinder:5,Sector:3 );
            write(' ', SecOfs:7,'    ', SecNum:6,'');

      end;
write('');
writeln('');

         end
        else writeln('訡  p 㯠  ᥪp p㧪');
      end;

{Ŀ}
{                                                       }
{}

var HrdDrive,                         { p  pp     }
    DError    : integer;              {  p㬥⮢               }

begin
writeln;
  HrdDrive := 0;                      {  㬮砭                      }
  if ParamCount = 1 then              { ᫨   pp        }
    begin
      val (ParamStr(1),HrdDrive,DError);   { ASCII  筮           }
      if DError <> 0 then                  { ᫨ 訡 pp   }
        begin
          writeln(#13#10'p 㪠 !');
          exit;
        end;
    end;
  ShowPartition ( HrdDrive );               { ⮡p ᥪp p   }
end.

